import { readFileSync } from 'fs';
import { _getDependenciesFromScripts } from '../../binaries/index.js';
import { getGitHookPaths } from '../../util/git.js';
import { FAKE_PATH } from '../../util/loader.js';
import { timerify } from '../../util/Performance.js';
import { hasDependency } from '../../util/plugin.js';
export const NAME = 'husky';
export const ENABLERS = ['husky'];
export const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
const gitHookPaths = getGitHookPaths('.husky');
export const CONFIG_FILE_PATTERNS = [...gitHookPaths];
const findHuskyDependencies = async (configFilePath, options) => {
    const { cwd, manifest, isProduction } = options;
    if (isProduction || configFilePath === FAKE_PATH)
        return [];
    const script = readFileSync(configFilePath);
    return _getDependenciesFromScripts(String(script), {
        cwd,
        manifest,
        knownGlobalsOnly: true,
    });
};
export const findDependencies = timerify(findHuskyDependencies);
